/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ChannelOpenBody__
#define qpid_framing_ChannelOpenBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ChannelOpenBody : public AMQMethodBody
{
	// Method field declarations

    string outOfBand;
     

public:
    typedef boost::shared_ptr<ChannelOpenBody> shared_ptr;

	// Constructors and destructors

    ChannelOpenBody(ProtocolVersion& version,
        const string& outOfBand
        ) :
        AMQMethodBody(version),
        outOfBand(outOfBand)
    { }


    inline ChannelOpenBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ChannelOpenBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ChannelOpenBody() {}
    
    // Attribute get methods

    inline const string& getOutOfBand() { return outOfBand; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ChannelOpen: ";
        out << "outOfBand=" << outOfBand;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 20;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + outOfBand.length(); /* outOfBand: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(outOfBand); /* outOfBand: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(outOfBand); /* outOfBand: shortstr */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getChannelHandler()->open(channel,
                    outOfBand
                    );
    }


}; // class ChannelOpenBody


} // namespace framing
} // namespace qpid

#endif

