/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ExchangeBoundBody__
#define qpid_framing_ExchangeBoundBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ExchangeBoundBody : public AMQMethodBody
{
	// Method field declarations

    string exchange;
    string routingKey;
    string queue;
     

public:
    typedef boost::shared_ptr<ExchangeBoundBody> shared_ptr;

	// Constructors and destructors

    ExchangeBoundBody(ProtocolVersion& version,
        const string& exchange,
        const string& routingKey,
        const string& queue
        ) :
        AMQMethodBody(version),
        exchange(exchange),
        routingKey(routingKey),
        queue(queue)
    { }


    inline ExchangeBoundBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ExchangeBoundBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ExchangeBoundBody() {}
    
    // Attribute get methods

    inline const string& getExchange() { return exchange; }
    inline const string& getRoutingKey() { return routingKey; }
    inline const string& getQueue() { return queue; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ExchangeBound: ";
        out << "exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; queue=" << queue;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 40;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 22;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1 + routingKey.length(); /* routingKey: shortstr */
        size += 1 + queue.length(); /* queue: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        buffer.putShortString(queue); /* queue: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        buffer.getShortString(queue); /* queue: shortstr */
    }       



}; // class ExchangeBoundBody


} // namespace framing
} // namespace qpid

#endif

